var beginningOfLine, bootstrapConversion, h, htmlEscape, ind, indentedJoin, run, smal, _, _base;

_ = require('lodash');

smal = require('smal');

if ((_base = String.prototype).trimRight == null) {
  _base.trimRight = function() {
    return this.replace(/\s+$/, '');
  };
}

h = htmlEscape = (function() {
  var badChars, escChar, escape, possible;
  escape = {
    "&": "&amp;",
    "<": "&lt;",
    ">": "&gt;",
    '"': "&quot;",
    "'": "&#x27;",
    "`": "&#x60;"
  };
  badChars = /[&<>"'`]/g;
  possible = /[&<>"'`]/;
  escChar = function(char) {
    return escape[char];
  };
  return function(string) {
    string = '' + string;
    if (!possible.test(string)) {
      return string;
    }
    return string.replace(badChars, escChar);
  };
})();

beginningOfLine = /^(?=.)/mg;

ind = function(indent, string) {
  return string.replace(beginningOfLine, indent);
};

indentedJoin = function(array, extraIndent) {
  if (extraIndent == null) {
    extraIndent = '';
  }
  return _.map(array, function(_arg) {
    var indent, text;
    indent = _arg[0], text = _arg[1];
    return text.replace(beginningOfLine, indent + extraIndent);
  }).join('\n') + '\n';
};

run = function(fn, dom, name, data) {
  var endFn, node, nodeData, nodeDom, nodeFn, nodeName, ob, _i, _len, _ref;
  if (name == null) {
    name = void 0;
  }
  if (data == null) {
    data = void 0;
  }
  ob = fn(name, data);
  for (_i = 0, _len = dom.length; _i < _len; _i++) {
    node = dom[_i];
    switch (node.length) {
      case 1:
        _ref = ['__TEXT__', []], nodeName = _ref[0], nodeDom = _ref[1];
        nodeData = node[0];
        break;
      case 2:
        nodeName = node[0], nodeDom = node[1];
        nodeData = [void 0][0];
        break;
      default:
        throw new Error('Invalid node');
    }
    nodeFn = ob[nodeName] || ob.__UNKNOWN__;
    if (nodeFn) {
      run(nodeFn, nodeDom, nodeName, nodeData);
    }
  }
  endFn = ob.__END__;
  if (endFn) {
    return endFn();
  }
};

bootstrapConversion = function() {
  var html, navbar, navbarInsideContainer, pageContent;
  html = [];
  html.push(['', "<!DOCTYPE html>\n<html lang=\"en\">"]);
  navbarInsideContainer = true;
  navbar = '';
  pageContent = '';
  return {
    title: function() {
      var title;
      title = null;
      return {
        __TEXT__: function(name, data) {
          return title = data;
        },
        __END__: function() {
          return html.push(['  ', "<head>\n  <meta charset=\"utf-8\">\n  <meta http-equiv=\"X-UA-Compatible\" content=\"IE=edge\">\n  <meta name=\"viewport\" content=\"width=device-width, initial-scale=1\">\n  <meta name=\"description\" content=\"\">\n  <meta name=\"author\" content=\"\">\n  <link rel=\"shortcut icon\" href=\"../../assets/ico/favicon.ico\">\n\n  <title>" + (h(title)) + "</title>\n\n  <!-- Bootstrap core CSS -->\n  <link href=\"../../dist/css/bootstrap.min.css\" rel=\"stylesheet\">\n\n  <!-- Custom styles for this template -->\n  <link href=\"navbar-static-top.css\" rel=\"stylesheet\">\n\n  <!-- Just for debugging purposes. Don't actually copy this line! -->\n  <!--[if lt IE 9]><script src=\"../../assets/js/ie8-responsive-file-warning.js\"></script><![endif]-->\n\n  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->\n  <!--[if lt IE 9]>\n    <script src=\"https://oss.maxcdn.com/libs/html5shiv/3.7.0/html5shiv.js\"></script>\n    <script src=\"https://oss.maxcdn.com/libs/respond.js/1.4.2/respond.min.js\"></script>\n  <![endif]-->\n</head>"]);
        }
      };
    },
    navbar: function() {
      var brand, menuLeft, menuRight, navbarClass, targetMenu;
      navbarClass = 'navbar navbar-default';
      brand = '';
      menuLeft = [];
      menuRight = [];
      targetMenu = menuLeft;
      return {
        "static": function() {
          navbarInsideContainer = false;
          return navbarClass = 'navbar navbar-default navbar-static-top';
        },
        fixed: function() {
          navbarInsideContainer = false;
          return navbarClass = 'navbar navbar-default navbar-fixed-top';
        },
        brand: function() {
          var text, to;
          text = '';
          to = '';
          return {
            __TEXT__: function(name, data) {
              return text = data;
            },
            to: function() {
              return {
                __TEXT__: function(name, data) {
                  return to = data;
                }
              };
            },
            __END__: function() {
              return brand = "<a class=\"navbar-brand\" href=\"" + (h(to)) + "\">" + (h(text)) + "</a>";
            }
          };
        },
        item: function() {
          var isActive, subItems, text, to;
          text = '';
          to = '#';
          isActive = false;
          subItems = [];
          return {
            __TEXT__: function(name, data) {
              return text = data;
            },
            to: function() {
              return {
                __TEXT__: function(name, data) {
                  return to = data;
                }
              };
            },
            active: function() {
              return isActive = true;
            },
            item: function() {
              var isActive_2, text_2, to_2;
              text_2 = '';
              to_2 = '#';
              isActive_2 = false;
              return {
                __TEXT__: function(name, data) {
                  return text_2 = data;
                },
                to: function() {
                  return {
                    __TEXT__: function(name, data) {
                      return to_2 = data;
                    }
                  };
                },
                active: function() {
                  return isActive_2 = true;
                },
                __END__: function() {
                  return subItems.push(['', "<li" + (isActive_2 ? ' class="active"' : '') + "><a href=\"" + (h(to_2)) + "\">" + (h(text_2)) + "</a></li>"]);
                }
              };
            },
            divider: function() {
              return subItems.push(['', "<li class=\"divider\"></li>"]);
            },
            header: function() {
              var text_2;
              text_2 = '';
              return {
                __TEXT__: function(name, data) {
                  return text_2 = data;
                },
                __END__: function() {
                  return subItems.push(['', "<li class=\"dropdown-header\">" + (h(text_2)) + "</li>"]);
                }
              };
            },
            __END__: function() {
              if (subItems.length > 0) {
                return targetMenu.push(['', "<li class=\"dropdown" + (isActive ? ' active' : '') + "\">\n  <a href=\"#\" class=\"dropdown-toggle\" data-toggle=\"dropdown\">" + (h(text)) + " <b class=\"caret\"></b></a>\n  <ul class=\"dropdown-menu\">\n    " + (indentedJoin(subItems, '    ').trim()) + "\n  </ul>\n</li>"]);
              } else {
                return targetMenu.push(['', "<li" + (isActive ? ' class="active"' : '') + "><a href=\"" + (h(to)) + "\">" + (h(text)) + "</a></li>"]);
              }
            }
          };
        },
        space: function() {
          return targetMenu = menuRight;
        },
        __END__: function() {
          menuLeft = menuLeft.length > 0 ? "<ul class=\"nav navbar-nav\">\n  " + (indentedJoin(menuLeft, '  ').trim()) + "\n</ul>" : '';
          menuRight = menuRight.length > 0 ? "<ul class=\"nav navbar-nav navbar-right\">\n  " + (indentedJoin(menuRight, '  ').trim()) + "\n</ul>" : '';
          return navbar = "<div class=\"" + (h(navbarClass)) + "\" role=\"navigation\">\n  <div class=\"" + (navbarInsideContainer ? "container-fluid" : "container") + "\">\n    <div class=\"navbar-header\">\n      <button type=\"button\" class=\"navbar-toggle\" data-toggle=\"collapse\" data-target=\".navbar-collapse\">\n        <span class=\"sr-only\">Toggle navigation</span>\n        <span class=\"icon-bar\"></span>\n        <span class=\"icon-bar\"></span>\n        <span class=\"icon-bar\"></span>\n      </button>\n      " + (ind('      ', brand).trim()) + "\n    </div>\n    <div class=\"navbar-collapse collapse\">\n      " + (ind('      ', menuLeft).trim()) + "\n      " + (ind('      ', menuRight).trim()) + "\n    </div><!--/.nav-collapse -->\n  </div>\n</div>";
        }
      };
    },
    jumbotron: function() {
      var jumbotron;
      jumbotron = [];
      jumbotron.push(['', "<!-- Main component for a primary marketing message or call to action -->\n<div class=\"jumbotron\">"]);
      return {
        header: function() {
          var text;
          text = null;
          return {
            __TEXT__: function(name, data) {
              return text = data;
            },
            __END__: function() {
              return jumbotron.push(['  ', "<h1>" + (h(text)) + "</h1>"]);
            }
          };
        },
        p: function() {
          var text;
          text = null;
          return {
            __TEXT__: function(name, data) {
              return text = data;
            },
            __END__: function() {
              return jumbotron.push(['  ', "<p>" + (h(text)) + "</p>"]);
            }
          };
        },
        button: function() {
          var text, to, type;
          type = 'default';
          text = null;
          to = '';
          return {
            primary: function() {
              return type = 'primary';
            },
            __TEXT__: function(name, data) {
              return text = data;
            },
            to: function() {
              return {
                __TEXT__: function(name, data) {
                  return to = data;
                }
              };
            },
            __END__: function() {
              return jumbotron.push(['  ', "<p>\n  <a class=\"btn btn-lg btn-" + type + "\" href=\"" + (h(to)) + "\" role=\"button\">" + (h(text)) + "</a>\n</p>"]);
            }
          };
        },
        __END__: function() {
          jumbotron.push(['', "</div>"]);
          return pageContent = indentedJoin(jumbotron);
        }
      };
    },
    __END__: function() {
      var containerStart;
      html.push(['  ', "<body>"]);
      containerStart = "<div class=\"container\">";
      if (navbarInsideContainer) {
        html.push(['    ', containerStart]);
        html.push(['      ', navbar]);
      } else {
        html.push(['    ', navbar]);
        html.push(['    ', containerStart]);
      }
      html.push(['      ', pageContent.trimRight()]);
      html.push(['    ', "</div> <!-- /container -->"]);
      html.push(['    ', "\n<!-- Bootstrap core JavaScript\n================================================== -->\n<!-- Placed at the end of the document so the pages load faster -->\n<script src=\"https://ajax.googleapis.com/ajax/libs/jquery/1.11.0/jquery.min.js\"></script>\n<script src=\"../../dist/js/bootstrap.min.js\"></script>"]);
      html.push(['  ', "</body>"]);
      html.push(['', "</html>"]);
      return indentedJoin(html);
    }
  };
};

module.exports = function(input) {
  return run(bootstrapConversion, smal.Parser().parse(input));
};
